﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Reflection.Emit;
using HarmonyLib;
using UnityEngine;
using UnityEngine.UI;

namespace ToggleSprint {
    public class ToggleSprint : Mod {
        private Harmony harmony;
        private readonly string harmonyID = "de.coolgaming.raftmodding.togglesprint";
        public static bool sprintDown = false;
        private bool oldRunToggleValue;
        private Toggle runToggle;
        public void Start() {
            harmony = new Harmony(harmonyID);
            harmony.PatchAll(Assembly.GetExecutingAssembly());
            runToggle = Traverse.Create(ComponentManager<global::Settings>.Value.controls).Field("toggleRunToggle").GetValue() as Toggle;
            oldRunToggleValue = runToggle.isOn;
            Debug.Log("Mod ToggleSprint has been loaded!");
        }

        public void Update() {
            if (MyInput.GetButtonDown("Sprint")) {
                runToggle.isOn = false;
                sprintDown = !sprintDown;
            }
            if (MyInput.GetAxis("Walk") == 0f && MyInput.GetAxis("Strafe") == 0f) {
                sprintDown = false;
            }
        }

        public void OnModUnload() {
            harmony.UnpatchAll(harmonyID);
            runToggle.isOn = oldRunToggleValue;
            Debug.Log("Mod ToggleSprint has been unloaded!");
        }
    }

    [HarmonyPatch(typeof(PersonController), "GroundControll")]
    class PersonController_GroundControll_Patch {
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions) {
            var orWithSprintToggleField = new List<CodeInstruction>() {
                new CodeInstruction(OpCodes.Ldsfld, typeof(ToggleSprint).GetField("sprintDown", BindingFlags.Public | BindingFlags.Static)),
                new CodeInstruction(OpCodes.Or)
            };

            var codes = new List<CodeInstruction>(instructions);
            var firstMatch = true;
            for (int i = 0; i < codes.Count; i++) {
                if (codes[i].opcode == OpCodes.Ldstr && (string)codes[i].operand == "Sprint") {
                    if (firstMatch) {
                        firstMatch = false;
                        continue;
                    }
                    codes.InsertRange(i + 2, orWithSprintToggleField);
                    break;
                }
            }

            return codes.AsEnumerable();
        }
    }
}